### A free/open-source library for quantitative finance

Public Member Functions
BSpline Class Reference

B-spline basis functions. More...

`#include <ql/math/bspline.hpp>`

List of all members.

## Public Member Functions

| BSpline (Natural p, Natural n, const std::vector< Real > &knots)
Real | operator() (Natural i, Real x) const

## Detailed Description

B-spline basis functions.

Follows treatment and notation from:

Weisstein, Eric W. "B-Spline." From MathWorld--A Wolfram Web Resource. <http://mathworld.wolfram.com/B-Spline.html>

-th order B-spline (or p degree polynomial) basis functions , with control points, or equivalently, an associated knot vector of size defined at the increasingly sorted points . A linear B-spline has , quadratic B-spline has , a cubic B-spline has , etc.

The B-spline basis functions are defined recursively as follows: